org.apache.poi.poifs.crypt.standard

## Class StandardDecryptor

- java.lang.Object
- - org.apache.poi.poifs.crypt.Decryptor
  - - org.apache.poi.poifs.crypt.standard.StandardDecryptor

- All Implemented Interfaces:
    GenericRecord

      public class StandardDecryptor
      extends Decryptor

- - ### Field Summary

    - ### Fields inherited from class org.apache.poi.poifs.crypt.Decryptor

      `DEFAULT_PASSWORD, DEFAULT_POIFS_ENTRY, encryptionInfo`

  - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `protected` | `StandardDecryptor()`
    `protected` | `StandardDecryptor(StandardDecryptor other)`

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `StandardDecryptor` | `copy()`
    `protected static byte[]` | `fillAndXor(byte[] hash, byte fillByte)`
    `protected static javax.crypto.SecretKey` | `generateSecretKey(java.lang.String password, EncryptionVerifier ver, int keySize)`
    `java.io.InputStream` | `getDataStream(DirectoryNode dir)` Return a stream with decrypted data.
    `long` | `getLength()` Returns the length of the encrypted data that can be safely read with `Decryptor.getDataStream(org.apache.poi.poifs.filesystem.DirectoryNode)`.
    `boolean` | `verifyPassword(java.lang.String password)`

    - ### Methods inherited from class org.apache.poi.poifs.crypt.Decryptor

      `getBlockSizeInBytes, getDataStream, getDataStream, getEncryptionInfo, getGenericProperties, getInstance, getIntegrityHmacKey, getIntegrityHmacValue, getKeySizeInBytes, getSecretKey, getVerifier, initCipherForBlock, setChunkSize, setEncryptionInfo, setIntegrityHmacKey, setIntegrityHmacValue, setSecretKey, setVerifier`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface org.apache.poi.common.usermodel.GenericRecord

      `getGenericChildren, getGenericRecordType`

- - ### Constructor Detail

    - #### StandardDecryptor

          protected StandardDecryptor()

    - #### StandardDecryptor

          protected StandardDecryptor(StandardDecryptor other)

  - ### Method Detail

    - #### verifyPassword

          public boolean verifyPassword(java.lang.String password)

      Specified by:
        `verifyPassword` in class `Decryptor`

    - #### generateSecretKey

          protected static javax.crypto.SecretKey generateSecretKey(java.lang.String password,
                                                                    EncryptionVerifier ver,
                                                                    int keySize)

    - #### fillAndXor

          protected static byte[] fillAndXor(byte[] hash,
                                             byte fillByte)

    - #### getDataStream

          public java.io.InputStream getDataStream(DirectoryNode dir)
                                            throws java.io.IOException

      Description copied from class: `Decryptor`
      Return a stream with decrypted data.

      Use `Decryptor.getLength()` to get the size of that data that can be safely read from the stream. Just reading to the end of the input stream is not sufficient because there are normally padding bytes that must be discarded

      Specified by:
        `getDataStream` in class `Decryptor`
      Parameters:
        `dir` - the node to read from
      Returns:
        decrypted stream
      Throws:
        `java.io.IOException`

    - #### getLength

          public long getLength()

      Description copied from class: `Decryptor`
      Returns the length of the encrypted data that can be safely read with `Decryptor.getDataStream(org.apache.poi.poifs.filesystem.DirectoryNode)`. Just reading to the end of the input stream is not sufficient because there are normally padding bytes that must be discarded

      The length variable is initialized in `Decryptor.getDataStream(org.apache.poi.poifs.filesystem.DirectoryNode)`, an attempt to call getLength() prior to getDataStream() will result in IllegalStateException.

      Specified by:
        `getLength` in class `Decryptor`
      Returns:
        the length of the stream returned by `getDataStream(DirectoryNode)`

    - #### copy

          public StandardDecryptor copy()

      Specified by:
        `copy` in class `Decryptor`

Copyright 2020 The Apache Software Foundation or its licensors, as applicable.